Subject: Re: bug#65797: `buffer-match-p` should not use `func-arity`

From: Philip Kaludercic <[email-masked]>
Date: Mon, 18 Sep 2023 09:12:45 +0000

Stefan Monnier <[email-masked]> writes:

>>>> FWIW The intention here was to be able and specify simpler conditions
>>>> that don't have to handle the alist.
>>> You mean for `display-buffer-alist`?
>>> Do you have examples that rely on this?
>> From the core?  No, I cannot think of an example, but any user
>> configuration may make use of this feature.
>
> From the core would have been good, but from elsewhere (including
> random .emacs config you may find on the web) would be helpful to gauge
> how important that could be.

I don't know of any examples.

>> I am not sure if I just missed it, but is there no technical solution
>> around the advice issue?  Couldn't `func-arity' check if the actual
>> function and the advice function have the same arity, and return the
>> right value in that case?  My impression is that in 99% of the cases,
>> advice isn't used to increase or decrease the arity of a function.
>
> There are various 99% solutions, yes.
> There is no 100% solution, OTOH :-(
> So the documented behavior is inherently unreliable.

So what are the options then?  Does one have to pick a 99% solution?

-- 
Philip Kaludercic